import { AddressRequestDTO } from '../create.address.request';

export function hasProperPositionIndexes(value: AddressRequestDTO[]) {
  if (value.every((address) => address.position === undefined)) return true;
  else if (value.every((address) => typeof address.position === 'number')) {
    value.sort((a, b) => a.position - b.position);
    for (let i = 1; i < value.length; i++) {
      if (value[i - 1].position >= value[i].position) return false;
    }
    return true;
  }
  return false;
}
