import { ValidateBy, ValidationOptions, buildMessage } from 'class-validator';
import { AddressRequestDTO } from '../../create.address.request';
import { hasProperPositionIndexes } from '../address-position';

export function HasProperPositionIndexes(
  validationOptions?: ValidationOptions,
): PropertyDecorator {
  return ValidateBy(
    {
      name: '',
      constraints: [],
      validator: {
        validate: (value: AddressRequestDTO[]): boolean =>
          hasProperPositionIndexes(value),

        defaultMessage: buildMessage(
          () =>
            `indexes position incorrect, please provide a complete list of indexes or ordened list of adresses from start to end of journey`,
          validationOptions,
        ),
      },
    },
    validationOptions,
  );
}
