import {
  ValidateBy,
  ValidationArguments,
  ValidationOptions,
  buildMessage,
} from 'class-validator';
import { hasProperPassengerSeats } from '../has-passenger-seats';

export function HasProperPassengerSeats(
  validationOptions?: ValidationOptions,
): PropertyDecorator {
  return ValidateBy(
    {
      name: '',
      constraints: [],
      validator: {
        validate: (value, args: ValidationArguments): boolean =>
          hasProperPassengerSeats(args),
        defaultMessage: buildMessage(
          () => `passenger and passenger seats are not correct`,
          validationOptions,
        ),
      },
    },
    validationOptions,
  );
}
