import { ValidationArguments } from 'class-validator';
import { Frequency } from '../../types/frequency.enum';

function isPunctual(args: ValidationArguments): boolean {
  if (
    args.object['frequency'] === Frequency.PUNCTUAL &&
    args.object['departure'] instanceof Date &&
    !Object.keys(args.object['schedule']).length
  )
    return true;
  return false;
}

function isRecurrent(args: ValidationArguments): boolean {
  if (
    args.object['frequency'] === Frequency.RECURRENT &&
    args.object['fromDate'] instanceof Date &&
    args.object['toDate'] instanceof Date &&
    Object.keys(args.object['schedule']).length
  )
    return true;
  return false;
}

export const isPunctualOrRecurrent = (args: ValidationArguments): boolean => {
  return isPunctual(args) || isRecurrent(args);
};
